--RETURN full professor teachers who are supervisioning bachelor students

SELECT DISTINCT t.name, t.surname, t.code
FROM teachers t JOIN students s ON t.code=s.supervisor
WHERE  s.program='bachelor'

--RETURN teachers who are not supervisioning bachelor students

SELECT t.name, t.surname, t.code
FROM teachers t
EXCEPT
SELECT t.name, t.surname, t.code
FROM teachers t JOIN students s ON t.code=s.supervisor
WHERE  s.program='bachelor'

--List the tutors who in databases exam have a greater mark than at 
-- least one of their students

SELECT DISTINCT s1.name, s1.surname, s1.studentID
FROM students s1 JOIN tutoring t ON t.tutor=s1.studentID JOIN exams e1
ON e1.student=s1.studentID JOIN courses c1 ON c1.code=e1.course JOIN students s2 ON t.student=s2.studentID JOIN exams e2 ON s2.studentID=e2.student 
WHERE e1.course=e2.course AND c1.title ='databases' AND e1.mark > e2.mark

--List teachers supervisioning students having at least one mark less than 25 or students with a mark greater than 29. 

SELECT DISTINCT t.name, t.surname, t.code
FROM Teachers t JOIN students s ON s.supervisor=t.code JOIN exams e ON 
e.student=s.studentID
WHERE e.mark < 25 OR e.mark > 29










